#include <stdio.h>
#include <stdlib.h>
#include <limits.h>
#include <math.h>
#include <string.h>
#include "grb2.h"
#include "wgrib2.h"
#include "fnlist.h"

/*
 * the set options
 *
 * routines make a generic PDT
 *
 * 9/2008 Public Domain by Wesley Ebisuzaki
 *
 */

/*
 * HEADER:100:set_pdt:misc:1:makes new (clean) pdt, X=PDT_number or X=PDT_number:size of PDT in octets
 */


int f_set_pdt(ARG1) {

    int pdt, i, len;
    
    static unsigned char new_sec4[SET_PDT_SIZE];

    if (mode < 0) return 0;

    i = sscanf(arg1,"%d:%d", &pdt, &len);

    if (i == 0) fatal_error("set_pdt: X=PDT_number[:PDT_SIZE]","");

    if (i == 1) {	// use default PDT size

        switch(pdt) {

        case 0: len = 34; break;
        case 1: len = 37; break;
        case 2: len = 36; break;
        default: fatal_error_i("set_pdt: unsupported pdt=%d",pdt); break;
        }
    }

    if (len > SET_PDT_SIZE) fatal_error_i("set_pdt: maximum pdt len is %d", SET_PDT_SIZE);


    uint_char(len, new_sec4);		    // size of sec[4];
    new_sec4[4] = 4;                        // section number
    uint2_char(0, new_sec4+5);              // no extra coordinates
    uint2_char(pdt, new_sec4+7);            // pdt
    for (i = 9; i < len; i++) new_sec4[i] = 255;

    sec[4] = &(new_sec4[0]);
    return 0;
}
